﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using HeuristicLab.Core;
using HeuristicLab.CEDMA.Core;

namespace HeuristicLab.CEDMA.Core {
  public partial class TableResultsView : ViewBase, IResultsView {
    private Results results;
    public TableResultsView() {
      InitializeComponent();
    }

    public Control Control {
      get { return this; }
    }

    string IResultsView.Name {
      get { return "Table"; }
    }

    public void ShowResults(Results results) {
      this.results = results;
      UpdateControls();
    }

    protected override void UpdateControls() {
      base.UpdateControls();
      if (results == null) return;
      dataGridView.Rows.Clear();
      dataGridView.Columns.Clear();
      List<string> attributeNames = results.SelectModelAttributes().ToList();
      foreach (var attribute in attributeNames) {
        dataGridView.Columns.Add(attribute, attribute);
      }

      var entries = results.SelectRows();
      foreach (var entry in entries) {
        int rowIndex = dataGridView.Rows.Add();
        foreach (string attrName in attributeNames) {
          dataGridView.Rows[rowIndex].Cells[attrName].Value = entry.Get(attrName);
        }
        dataGridView.Rows.Add(row);
      }
      dataGridView.Update();
    }
  }
}
